package com.michaelrac.mbwblue_demo;

import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.pm.ActivityInfo;
import android.graphics.Color;
import android.graphics.Typeface;
import android.media.AudioManager;
import android.media.ToneGenerator;
import android.os.AsyncTask;
import android.os.Handler;
import android.os.SystemClock;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Gravity;
import android.view.View;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.Spinner;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;
import android.widget.Toast;
import java.util.ArrayList;
import java.util.List;
import android.view.LayoutInflater;

import com.michaelrac.mbusracxv2.MBWBLUE;
import com.michaelrac.mbusracxv2.MBus;

import static android.content.pm.ActivityInfo.SCREEN_ORIENTATION_SENSOR;

public class MainActivity extends AppCompatActivity {
    private MBWBLUE MBL;
    private byte KeyFileKey[];
    private MBus MBS;

    private Handler timerHandler = new Handler();
    private int BTWorkerThreadTask;
    private boolean BTWorkerThreadTaskResult;
    private boolean BTWorkerThreadBreak;
    private TextView BTDeviceTypeTV;
    private TextView BTFWVersionTV;
    private TextView BTSerialNumberTV;
    private TextView BTMACAddressTV;
    private TextView BTFramesTotalTV;
    private TextView BTDevicesTotalTV;
    private TextView BTError36TV;
    private TextView BTModeTSStaticTV;
    private TextView BTModeTSTV;
    private TextView BTModeCStaticTV;
    private TextView BTModeCTV;
    private TextView BTErrorCRCTV;
    private TextView BTReadButtonTV;
    private int BTPrevOrientation;
    private int BTListEntriesMax;
    private int BTListCurRowCount;
    private int BTTelegramCount;
    private TextView BTListRow1Txt[];
    private TextView BTListRow2Txt[];
    private TextView BTListRow3Txt[];
    private TextView BTListRow4Txt[];
    private TextView BTListRow5Txt[];
    private TableRow BTListRow[];
    private TableLayout BTListLayout;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        BTList_Init();
        BTList_Clear();
        BTList_Fill();

        BTWorkerThreadTask=0;
        BTWorkerThreadTaskResult=false;
        BTWorkerThreadBreak=false;
        BTTelegramCount=0;
        MBL = new MBWBLUE("");
        KeyFileKey=new byte[16];
        KeyFileKey[ 0]=(byte)0x36;KeyFileKey[ 1]=(byte)0x98;KeyFileKey[ 2]=(byte)0xBF;KeyFileKey[ 3]=(byte)0x98;
        KeyFileKey[ 4]=(byte)0xAC;KeyFileKey[ 5]=(byte)0xED;KeyFileKey[ 6]=(byte)0x4E;KeyFileKey[ 7]=(byte)0xC3;
        KeyFileKey[ 8]=(byte)0xD9;KeyFileKey[ 9]=(byte)0x72;KeyFileKey[10]=(byte)0x21;KeyFileKey[11]=(byte)0xAE;
        KeyFileKey[12]=(byte)0x6B;KeyFileKey[13]=(byte)0x80;KeyFileKey[14]=(byte)0xFA;KeyFileKey[15]=(byte)0x23;
        MBS = new MBus(getApplicationContext(),KeyFileKey);
        if (!MBL.BTAdapterOK)
            Toast.makeText(getApplicationContext(), "Your device does not support Bluetooth", Toast.LENGTH_LONG).show();
        else
            Toast.makeText(getApplicationContext(), "Bluetooth adapter initialised", Toast.LENGTH_LONG).show();
        BTDeviceSpinnerFill();
        BTModeSpinnerFill();

        BTDeviceTypeTV=new TextView(this);
        BTDeviceTypeTV=(TextView)findViewById(R.id.BTDeviceType);
        BTDeviceTypeTV.setText("");
        BTFWVersionTV=new TextView(this);
        BTFWVersionTV=(TextView)findViewById(R.id.BTFWVersion);
        BTFWVersionTV.setText("");
        BTSerialNumberTV=new TextView(this);
        BTSerialNumberTV=(TextView)findViewById(R.id.BTSerialNumber);
        BTSerialNumberTV.setText("");
        BTMACAddressTV=new TextView(this);
        BTMACAddressTV=(TextView)findViewById(R.id.BTMACAddress);
        BTMACAddressTV.setText("");
        BTFramesTotalTV=new TextView(this);
        BTFramesTotalTV=(TextView)findViewById(R.id.BTFramesTotal);
        BTFramesTotalTV.setText("");
        BTDevicesTotalTV=new TextView(this);
        BTDevicesTotalTV=(TextView)findViewById(R.id.BTDevicesTotal);
        BTDevicesTotalTV.setText("");
        BTError36TV=new TextView(this);
        BTError36TV=(TextView)findViewById(R.id.BTError36);
        BTError36TV.setText("");
        BTModeTSStaticTV=new TextView(this);
        BTModeTSStaticTV=(TextView)findViewById(R.id.BTModeTSStatic);
        BTModeTSStaticTV.setText("Mod T");
        BTModeTSTV=new TextView(this);
        BTModeTSTV=(TextView)findViewById(R.id.BTModeTS);
        BTModeTSTV.setText("");
        BTModeCStaticTV=new TextView(this);
        BTModeCStaticTV=(TextView)findViewById(R.id.BTModeCStatic);
        BTModeCStaticTV.setText("Mod C");
        BTModeCTV=new TextView(this);
        BTModeCTV=(TextView)findViewById(R.id.BTModeC);
        BTModeCTV.setText("");
        BTErrorCRCTV=new TextView(this);
        BTErrorCRCTV=(TextView)findViewById(R.id.BTErrorCRC);
        BTErrorCRCTV.setText("");
        BTReadButtonTV=new TextView(this);
        BTReadButtonTV=(TextView)findViewById(R.id.BTRadioReading);
        BTReadButtonTV.setText("Reading");
        BTPrevOrientation=getRequestedOrientation();
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTList_Init() {
        TableLayout BTLHTLay = (TableLayout) findViewById(R.id.BTListHeaderTable);
        TableRow BTLHTabRowh = new TableRow(this);
        TextView tvh0 = new TextView(this);
        tvh0.setText("Time");
        tvh0.setTypeface(null, Typeface.BOLD);
        tvh0.setWidth(200);
        BTLHTabRowh.addView(tvh0);
        TextView tvh1 = new TextView(this);
        tvh1.setText("Man");
        tvh1.setTypeface(null, Typeface.BOLD);
        tvh1.setWidth(120);
        BTLHTabRowh.addView(tvh1);
        TextView tvh2 = new TextView(this);
        tvh2.setText("Address");
        tvh2.setTypeface(null, Typeface.BOLD);
        tvh2.setWidth(240);
        BTLHTabRowh.addView(tvh2);
        TextView tvh3 = new TextView(this);
        tvh3.setText("Signal");
        tvh3.setTypeface(null, Typeface.BOLD);
        tvh3.setWidth(140);
        BTLHTabRowh.addView(tvh3);
        TextView tvh4 = new TextView(this);
        tvh4.setText("Value 1");
        tvh4.setTypeface(null, Typeface.BOLD);
        tvh4.setWidth(800);
        BTLHTabRowh.addView(tvh4);
        BTLHTLay.addView(BTLHTabRowh);
        BTListEntriesMax=250;
        BTListRow1Txt=new TextView[BTListEntriesMax];
        BTListRow2Txt=new TextView[BTListEntriesMax];
        BTListRow3Txt=new TextView[BTListEntriesMax];
        BTListRow4Txt=new TextView[BTListEntriesMax];
        BTListRow5Txt=new TextView[BTListEntriesMax];
        BTListRow=new TableRow [BTListEntriesMax];
        BTListCurRowCount=0;
        BTListLayout = (TableLayout) findViewById(R.id.BTListTable);
        for (int i=0;i<BTListEntriesMax;++i)
        {
            BTListRow[i] = new TableRow(this);
            BTListRow1Txt[i]=new TextView(this);
            BTListRow1Txt[i].setText("");
            BTListRow1Txt[i].setWidth(200);
            BTListRow[i].addView(BTListRow1Txt[i]);
            BTListRow2Txt[i]=new TextView(this);
            BTListRow2Txt[i].setText("");
            BTListRow2Txt[i].setWidth(120);
            BTListRow[i].addView(BTListRow2Txt[i]);
            BTListRow3Txt[i]=new TextView(this);
            BTListRow3Txt[i].setText("");
            BTListRow3Txt[i].setWidth(260);
            BTListRow[i].addView(BTListRow3Txt[i]);
            BTListRow4Txt[i]=new TextView(this);
            BTListRow4Txt[i].setText("");
            BTListRow4Txt[i].setWidth(140);
            BTListRow[i].addView(BTListRow4Txt[i]);
            BTListRow5Txt[i]=new TextView(this);
            BTListRow5Txt[i].setText("");
            BTListRow5Txt[i].setWidth(800);
            BTListRow[i].addView(BTListRow5Txt[i]);
        }
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTList_Clear() {
        int Counter;
        for (Counter=0;Counter<BTListEntriesMax;++Counter) {
            BTListRow1Txt[Counter].setText("");
            BTListRow2Txt[Counter].setText("");
            BTListRow3Txt[Counter].setText("");
            BTListRow4Txt[Counter].setText("");
            BTListRow5Txt[Counter].setText("");
        }
        BTListLayout.removeAllViews();
        BTListCurRowCount=0;
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTList_Fill() {
        for (int i = 0; i < BTListEntriesMax; ++i) {
            if (!(BTListRow1Txt[i].getText().equals(""))) {
                if (i >= BTListCurRowCount) {
                    BTListLayout.addView(BTListRow[i]);
                    BTListCurRowCount = i + 1;
                }
            }
        }
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTList_MoveUp(int SIndx) {
        int Counter;
        for (Counter=(BTListEntriesMax-2); Counter>=SIndx;--Counter) {
            BTListRow1Txt[Counter+1].setText(BTListRow1Txt[Counter].getText());
            BTListRow2Txt[Counter+1].setText(BTListRow2Txt[Counter].getText());
            BTListRow3Txt[Counter+1].setText(BTListRow3Txt[Counter].getText());
            BTListRow4Txt[Counter+1].setText(BTListRow4Txt[Counter].getText());
            BTListRow5Txt[Counter+1].setText(BTListRow5Txt[Counter].getText());
        }
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTList_SortIn(String Row1, String Row2, String Row3, String Row4, String Row5) {
        int Counter;
        String DStr1;
        for (Counter = 0; Counter < BTListCurRowCount; ++Counter) {
            DStr1=(String)BTListRow2Txt[Counter].getText();
            if (DStr1.compareTo(Row2)>0)
            {
                BTList_MoveUp(Counter);
                BTListRow1Txt[Counter].setText(Row1);
                BTListRow2Txt[Counter].setText(Row2);
                BTListRow3Txt[Counter].setText(Row3);
                BTListRow4Txt[Counter].setText(Row4);
                BTListRow5Txt[Counter].setText(Row5);
                Counter = BTListEntriesMax+1000;
            }
            else if (DStr1.compareTo(Row2)==0)
            {
                DStr1=(String)BTListRow3Txt[Counter].getText();
                if (DStr1.compareTo(Row3)>0)
                {
                    BTList_MoveUp(Counter);
                    BTListRow1Txt[Counter].setText(Row1);
                    BTListRow2Txt[Counter].setText(Row2);
                    BTListRow3Txt[Counter].setText(Row3);
                    BTListRow4Txt[Counter].setText(Row4);
                    BTListRow5Txt[Counter].setText(Row5);
                    Counter = BTListEntriesMax+1000;
                }
                else if (DStr1.compareTo(Row3)==0)
                {
                    BTListRow1Txt[Counter].setText(Row1);
                    BTListRow2Txt[Counter].setText(Row2);
                    BTListRow3Txt[Counter].setText(Row3);
                    BTListRow4Txt[Counter].setText(Row4);
                    BTListRow5Txt[Counter].setText(Row5);
                    Counter = BTListEntriesMax+1000;
                }
            }
        }
        if (Counter<BTListEntriesMax+1000) {
            if (BTListCurRowCount<BTListEntriesMax) {
                BTListRow1Txt[BTListCurRowCount].setText(Row1);
                BTListRow2Txt[BTListCurRowCount].setText(Row2);
                BTListRow3Txt[BTListCurRowCount].setText(Row3);
                BTListRow4Txt[BTListCurRowCount].setText(Row4);
                BTListRow5Txt[BTListCurRowCount].setText(Row5);
            }
        }
        BTList_Fill();
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTDeviceSpinnerFill() {
        int DSCounter;
        MBL.AvailableDevicesList();
        List<String> BTDevicesSpinnerArray = new ArrayList<String>();
        for (DSCounter = 0; DSCounter < MBL.AvailableDevicesCount(); ++DSCounter) {
            BTDevicesSpinnerArray.add(MBL.AvailableDevicesName(DSCounter));
        }
        if (MBL.AvailableDevicesCount() <= 0) BTDevicesSpinnerArray.add("No devices available");
        ArrayAdapter<String> BTDevicesSpinnerAdapter = new ArrayAdapter<String>(
                this, android.R.layout.simple_spinner_item, BTDevicesSpinnerArray);
        BTDevicesSpinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        Spinner BTDevicesSpinner = (Spinner) findViewById(R.id.BTDeviceList);
        BTDevicesSpinner.setAdapter(BTDevicesSpinnerAdapter);
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTModeSpinnerFill() {
        List<String> BTModeSpinnerArray = new ArrayList<String>();
        BTModeSpinnerArray.add("Mode C + T / 868 MHz");
        BTModeSpinnerArray.add("Mode S / 868 MHz");
        BTModeSpinnerArray.add("Mode C + T / 434 MHz");
        BTModeSpinnerArray.add("Mode S / 434 MHz");
        ArrayAdapter<String> BTModeSpinnerAdapter = new ArrayAdapter<String>(
                this, android.R.layout.simple_spinner_item, BTModeSpinnerArray);
        BTModeSpinnerAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        Spinner BTModeSpinner = (Spinner) findViewById(R.id.BTModeList);
        BTModeSpinner.setAdapter(BTModeSpinnerAdapter);
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTDeviceRefreshClicked(View view) {
        if (BTWorkerThreadTask!=0) return;
        BTDeviceSpinnerFill();
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTMBWBLUERead(View view) {
        if (BTWorkerThreadTask!=0) return;
        BTDeviceTypeTV.setText("");
        BTFWVersionTV.setText("");
        BTSerialNumberTV.setText("");
        BTMACAddressTV.setText("");
        Spinner BTDevicesSpinner = (Spinner) findViewById(R.id.BTDeviceList);
        MBL.BTDeviceName=(String) BTDevicesSpinner.getSelectedItem();
        if (!MBL.BTDeviceName.substring(0,2).equals("MB")) return;
        BTTelegramCount=0;
        BTWorkerThreadTaskResult=false;
        BTWorkerThreadBreak=false;
        BTWorkerThreadTask=1;           // Task 1 = read MBWBLUE
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);
        new BTWorkerThread().execute();
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTRadioReading(View view) {
        if (BTWorkerThreadTask!=0)
        {
            BTWorkerThreadBreak=true;
        }
        else {
            Spinner BTDevicesSpinner = (Spinner) findViewById(R.id.BTDeviceList);
            MBL.BTDeviceName=(String) BTDevicesSpinner.getSelectedItem();
            if (!MBL.BTDeviceName.substring(0,2).equals("MB")) return;
            Spinner BTModeSpinner = (Spinner) findViewById(R.id.BTModeList);
            int DInt = BTModeSpinner.getSelectedItemPosition();
            switch (DInt) {
                default:
                case 0:
                    MBL.BTCurReceiveMode=0;
                    MBL.BTCurReceiverFreq=868;
                    BTModeTSStaticTV.setText("Mode T");
                    BTModeCStaticTV.setText("Mode C");
                    break;
                case 1:
                    MBL.BTCurReceiveMode=1;
                    MBL.BTCurReceiverFreq=868;
                    BTModeTSStaticTV.setText("Mode S");
                    BTModeCStaticTV.setText("");
                    break;
                case 2:
                    MBL.BTCurReceiveMode=0;
                    MBL.BTCurReceiverFreq=434;
                    BTModeTSStaticTV.setText("Mode T");
                    BTModeCStaticTV.setText("Mode C");
                    break;
                case 3:
                    MBL.BTCurReceiveMode=1;
                    MBL.BTCurReceiverFreq=434;
                    BTModeTSStaticTV.setText("Mode S");
                    BTModeCStaticTV.setText("");
                    break;
            }
            BTList_Clear();
            BTFramesTotalTV.setText("");
            BTDevicesTotalTV.setText("");
            BTError36TV.setText("");
            BTModeTSTV.setText("");
            BTModeCTV.setText("");
            BTErrorCRCTV.setText("");
            BTReadButtonTV.setText("Stop");
            BTWorkerThreadTaskResult = false;
            BTWorkerThreadBreak=false;
            BTWorkerThreadTask = 2;       // Task 2 = read radio devices
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);
            new BTWorkerThread().execute();
        }
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public void BTSettings(View view)
    {
        if (BTWorkerThreadTask!=0) return;

        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        LayoutInflater inflater = this.getLayoutInflater();
        final View dialogView =inflater.inflate(R.layout.settings_dialog, null);
        builder.setView(dialogView);
        final EditText edt = (EditText) dialogView.findViewById(R.id.settingsedit);
        edt.setText(MBS.CryptoKeysGetKey(0,0));
        builder.setMessage("Enter 32 characters HEX radio key");
        builder.setPositiveButton("OK", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int id) {
                String DStr,DStr2;
                char DChar;
                int Counter;
                DStr2="";
                DStr=edt.getText().toString();
                for (Counter=0;Counter<DStr.length();++Counter)
                {
                    DChar=DStr.charAt(Counter);
                    if ((DChar>='a') && (DChar<='f')) DChar=(char)((byte)DChar-0x20);
                    if ((DChar<'0') || ((DChar>'9') && (DChar<'A')) || (DChar>'F')) DChar='0';
                    DStr2=DStr2+DChar;
                }
                DStr2=DStr2+"00000000000000000000000000000000";
                MBS.CryptoKeysDelete(0,0);
                MBS.CryptoKeysDelete(1,0);
                DStr2=DStr2.substring(0,32);
                MBS.CryptoKeysAddOrModify(0, -1, DStr2, "");
                DStr2=DStr2.substring(0,16);
                MBS.CryptoKeysAddOrModify(1, -1, DStr2, "");
                MBS.CryptoKeysWrite();
            }
        });
        builder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int id) {
            }
        });
        AlertDialog b = builder.create();
        b.show();
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public String BTFormatMBSTime() {
        String RetString;
        RetString="";
        if (MBS.RecHour<10) RetString=RetString+"0";
        RetString=RetString+String.valueOf(MBS.RecHour);
        RetString=RetString+":";
        if (MBS.RecMinute<10) RetString=RetString+"0";
        RetString=RetString+String.valueOf(MBS.RecMinute);
        RetString=RetString+":";
        if (MBS.RecSecond<10) RetString=RetString+"0";
        RetString=RetString+String.valueOf(MBS.RecSecond);
        return RetString;
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    Runnable timerRunnable = new Runnable() {
        @Override
        public void run() {
            boolean BTStartFWUpdate=false;
            boolean BTStartReading=false;
            int BTPostAgain=0;
            switch (BTWorkerThreadTask) {
                default:
                case 0:
                    break;
                case 1:         // Task 1 = Reading MBWBLUE
                    if (BTWorkerThreadTaskResult) {
                        BTDeviceTypeTV.setText(MBL.BTDevType);
                        BTFWVersionTV.setText(MBL.BTFWVersion);
                        BTSerialNumberTV.setText(MBL.BTSerialNumber);
                        BTMACAddressTV.setText(MBL.BTMACAddress);
                        Spinner BTModeSpinner = (Spinner) findViewById(R.id.BTModeList);
                        int DInt=BTModeSpinner.getSelectedItemPosition();
                        if ((DInt>1) && (MBL.BTFreq==868)) {
                            BTModeSpinner.setSelection(DInt-2);
                        }
                        else if ((DInt<2) && (MBL.BTFreq==434)) {
                            BTModeSpinner.setSelection(DInt+2);
                        }
                        if (MBL.BTGen3==1) {
                            Double DVerDevice, DVerUpd;
                            DVerDevice = (Double.parseDouble(MBL.BTFWVersion) + 0.0000001);
                            DVerUpd = Double.parseDouble(MBL.BTUpdateFWVersion);
                            if (DVerUpd > DVerDevice) BTStartFWUpdate = true;
                        }
                    }
                    else BTDeviceTypeTV.setText("Error");
                    BTWorkerThreadTask=0;
                    break;
                case 2:         // Task 2 = Reading radio devices
                    if (MBS.IsValid) {
                        BTList_SortIn(BTFormatMBSTime(),MBS.ManFieldTPL,MBS.AdrFieldTPL,(MBL.BTTelgRSSI+" %"),(MBS.DRValueStr[0]+" "+MBS.DRVIFTxt[0]));
                        MBS.IsValid=false;
                    }
                    if (MBL.BTGen3==1) {
                        BTFramesTotalTV.setText(String.valueOf(MBL.BTStatisticsGoodFrameTS + MBL.BTStatisticsGoodFrameCB + MBL.BTStatisticsGoodFrameCB));
                        BTDevicesTotalTV.setText(String.valueOf(BTListCurRowCount));
                        BTModeTSTV.setText(String.valueOf(MBL.BTStatisticsGoodFrameTS));
                        BTModeCTV.setText(String.valueOf(MBL.BTStatisticsGoodFrameCB + MBL.BTStatisticsGoodFrameCB));
                        BTError36TV.setText(String.valueOf(MBL.BTStatisticsError36));
                        BTErrorCRCTV.setText(String.valueOf(MBL.BTStatisticsErrorCRC));
                    }
                    else {
                        BTFramesTotalTV.setText(String.valueOf(BTTelegramCount));
                        BTDevicesTotalTV.setText(String.valueOf(BTListCurRowCount));
                        BTModeTSTV.setText("na");
                        BTModeCTV.setText("na");
                        BTError36TV.setText("na");
                        BTErrorCRCTV.setText("na");
                    }
                    if ((BTWorkerThreadBreak) || (!BTWorkerThreadTaskResult)) {
                        BTReadButtonTV.setText("Reading");
                        BTWorkerThreadTask=0;
                    }
                    break;
                case 3:
                    if (!BTWorkerThreadTaskResult) {
                        String PStr;
                        PStr="Firmware update in progress: "+String.valueOf(MBL.BTProgress)+" %";
                        Toast.makeText(getApplicationContext(), PStr, Toast.LENGTH_SHORT).show();
                        BTPostAgain=2500;
                    }
                    else {
                        switch(MBL.BTProgress) {
                            default:
                                Toast.makeText(getApplicationContext(), "Firmware update failed!", Toast.LENGTH_SHORT).show();
                                BTWorkerThreadTask=0;
                                break;
                            case 100:
                                ToneGenerator toneG = new ToneGenerator(AudioManager.STREAM_ALARM, 100);
                                toneG.startTone(ToneGenerator.TONE_CDMA_ALERT_CALL_GUARD, 200);
                                Toast.makeText(getApplicationContext(), "Switch MBWBLUE on!", Toast.LENGTH_LONG).show();
                                MBL.BTProgress=101;
                                BTPostAgain=12000;
                                break;
                            case 101:
                                ToneGenerator toneG2 = new ToneGenerator(AudioManager.STREAM_ALARM, 100);
                                toneG2.startTone(ToneGenerator.TONE_CDMA_ALERT_CALL_GUARD, 200);
                                Toast.makeText(getApplicationContext(), "Switch MBWBLUE on, again!", Toast.LENGTH_LONG).show();
                                MBL.BTProgress=102;
                                BTPostAgain=10000;
                                break;
                            case 102:
                                BTStartReading=true;
                                BTWorkerThreadTask=0;
                                break;
                        }
                    }
                    break;
            }
            timerHandler.removeCallbacks(timerRunnable);
            if (BTStartFWUpdate)
            {
                ToneGenerator toneG3 = new ToneGenerator(AudioManager.STREAM_ALARM, 100);
                toneG3.startTone(ToneGenerator.TONE_CDMA_ALERT_CALL_GUARD, 200);
                BTStartFWUpdate=false;
                BTWorkerThreadTaskResult=false;
                BTWorkerThreadBreak=false;
                BTWorkerThreadTask=3;           // Task 3 = MBWBLUE firwmare update
                setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);
                new BTWorkerThread().execute();
            }
            if (BTStartReading) {
                BTStartReading=false;
                BTDeviceTypeTV.setText("");
                BTFWVersionTV.setText("");
                BTSerialNumberTV.setText("");
                BTMACAddressTV.setText("");
                BTWorkerThreadTaskResult=false;
                BTWorkerThreadBreak=false;
                BTWorkerThreadTask=1;           // Task 1 = read MBWBLUE
                setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_NOSENSOR);
                new BTWorkerThread().execute();
            }
            if (BTPostAgain>0) timerHandler.postDelayed(timerRunnable, BTPostAgain);
        }
    };

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    public class BTWorkerThread extends AsyncTask<Void, Void, Void> {
        @Override
        protected Void doInBackground(Void... Params) {
            switch (BTWorkerThreadTask) {
                case 0:
                    break;
                default:
                    break;
//************************************************************************************************
                case 1:                // Read MBWBLUE parameters
                    BTWorkerThreadTaskResult=false;
                    if (MBL.BTConnect(MBL.AvailableDevicesGetAddressFromName(MBL.BTDeviceName))) {
                        if (MBL.BTCMDRequestFirmwareVersionLeg()) {
                            if (MBL.BTCMDReadROMLeg()) BTWorkerThreadTaskResult=true;
                        }
                        MBL.BTDisConnect();
                    }
                    timerHandler.postDelayed(timerRunnable, 0);
                    break;
//************************************************************************************************
                case 2:                // Read radio devices
                    int ErrorCounter=5;
                    BTWorkerThreadTaskResult=true;
                    if (MBL.BTConnect(MBL.AvailableDevicesGetAddressFromName(MBL.BTDeviceName))) {
                        if (MBL.BTCMDRequestFirmwareVersionLeg()) {
                            if (MBL.BTCMDReceiverModeLeg()) {
                                ErrorCounter=0;
                                while ((!BTWorkerThreadBreak) && (ErrorCounter<5)) {
                                    if (MBL.BTGen3==1) {    // Generation 3.x devices have more possibilities with different commands
                                        if (!MBL.BTCMDReadRadio()) ++ErrorCounter;
                                        else {
                                            while (MBS.IsValid) SystemClock.sleep(10);  // Frame content not already put in list
                                            if (MBS.Interpret(MBL.BTInBuffer,5,256,false))
                                            {
                                                ++BTTelegramCount;
                                            }
                                            else SystemClock.sleep(100);
                                            ErrorCounter = 0;
                                            timerHandler.postDelayed(timerRunnable, 0);
                                        }
                                    }
                                    else
                                    {
                                        if (!MBL.BTCMDReadRadioLeg()) ++ErrorCounter;
                                        else {
                                            while (MBS.IsValid) SystemClock.sleep(10);  // Frame content not already put in list
                                            if (MBS.Interpret(MBL.BTInBuffer,12,241,false))
                                            {
                                                ++BTTelegramCount;
                                            }
                                            else SystemClock.sleep(100);
                                            ++BTTelegramCount;
                                            ErrorCounter = 0;
                                            timerHandler.postDelayed(timerRunnable, 0);
                                        }
                                    }
                                }
                            }
                        }
                        MBL.BTDisConnect();
                    }
                    if (ErrorCounter>4) BTWorkerThreadTaskResult=false;
                    timerHandler.postDelayed(timerRunnable, 0);
                    break;
//************************************************************************************************
                case 3:                // MBWBLUE firmware update
                    timerHandler.postDelayed(timerRunnable, 1000);
                    MBL.BTProgress=0;
                    BTWorkerThreadTaskResult=false;
                    if (MBL.BTConnect(MBL.AvailableDevicesGetAddressFromName(MBL.BTDeviceName))) {
                        if (MBL.BTCMDMBWBLUEFirmwareUpdate()) MBL.BTCMDSwitchOff();
                        MBL.BTDisConnect();
                    }
                    BTWorkerThreadTaskResult=true;
                    timerHandler.postDelayed(timerRunnable, 0);
                    break;
//************************************************************************************************
            }
            return null;
        }
    }

//************************************************************************************************
//************************************************************************************************
//************************************************************************************************
    @Override
    protected void onDestroy()
    {
        setRequestedOrientation(BTPrevOrientation);
        MBL.Destroy();
        MBS.Destroy();
        super.onDestroy();
    }
}
